function Actor(x, y, image){
	this.x = x;
	this.y = y;
	this.stopped = true;
	this.image = image;
	this.maxStep = 8;// 32;
	this.currentStep = this.maxStep;

	this.directionX = 1; //default direction
	this.directionY = 0;

	this.updater;

	this.step = function(){
		this.currentStep++;

		if (this.currentStep > this.maxStep) {
			this.currentStep = 0;
			return false;
		}

		return true;
	}

	this.finsishStep = function(){
		if (this.currentStep < this.maxStep) {
			this.currentStep++;
			return false;
		}

		this.stopped = true;
		return true;
	}

	this.move = function(x, y) {
		this.stopped = false;
		this.x += x;
		this.y += y;

		this.directionX = x;
		this.directionY = y;

		this.currentStep = 0;
	}

	this.moveTo = function(cell) {
		this.stopped = false;
		
		var diffX = cell.x - this.x;
		var diffY = cell.y - this.y;

		this.x += diffX;
		this.y += diffY;

		this.directionX = diffX;
		this.directionY = diffY;

		this.currentStep = 0;	

	}

	this.update = function(level){
		if (this.updater == null || ! this.updater.active) {
			this.finsishStep();
			return;
		}

		if (this.step()) {
			return;
		}

		this.updater.updateActor(level, this);
	}

}










function NodeCell(x, y){
	this.x = x;
	this.y = y;
	this.selected = false;
	this.type;

	//used by astar...
	this.parent = null;
	this.cost = 1;
	this.heuristic = 0;

	this.areSame = function(nodeCell) {
		
		if (nodeCell.x == this.x && nodeCell.y == this.y){
			return true;
		} 

		return false;
	}
}









function Level(){
	this.id;
	this.title;
	this.description;

	this.timer = 0;
	
	this.actors = [];
	this.chief;
	this.minions = {};

	this.startNodeCell;
	this.endNodeCell;

	this.map;
	this.plainMap;

	this.renderer;

	this.nodeOutOfBounds = function(node){
		return this.outOfBounds(node.x, node.y);
	}

	this.outOfBounds = function(x, y){
		if (x < 0 || y < 0 || y > this.map.length || x > this.map[y].length){
			return true;
		}

		return false;
	}

	this.width = function(){
		this.map[0].width();
	}

	this.height = function(){
		this.map.width();
	}


	this.render = function(){
		this.renderer.render();
	}

	this.update = function(){
		for (var i = 0; i < this.actors.length; i++) {
			this.actors[i].update(this);
		};
	}

	this.isAccessible = function(x, y){
		if (this.outOfBounds(x, y)) {
			return false;
		}

		if (this.map[y][x].type == 3){
			return false;
		}

		//
		for (var i = 0; i < this.actors.length; i++) {
			if (! this.actors[i].stopped){
				continue;
			}

			if(this.actors[i].x == x && this.actors[i].y == y){
				return false;
			}
		};

		return true;
	}

	this.cellForActor = function(actor){
		var x = actor.x;
		var y = actor.y;

		if (this.outOfBounds(x, y)){
			return null;
		}

		return this.map[y][x];
	}

}


