function GridRenderer() {

	this.canvas;
	this.context;
	this.cellSize;
	this.padding;
	this.level;
	this.gridLeftOffset;

	this.width;
	this.height;

	this.menuTopOffset = 0;
	this.menuLeftOffset = 0;
	this.menuPadding = 5;

	this.selectedMenu = "blocker";

	//this.menu = [ "blocker", "exploser", "fighter" ];
	this.menu = [ "blocker" ];


	this.prepare = function(){
		this.context = this.canvas.getContext("2d");
		this.width  = this.gridLeftOffset + (this.padding + this.cellSize) * 20; //selon map ?
		this.height = (this.padding + this.cellSize) * 11;

		this.canvas.width  = this.width;
		this.canvas.height = this.height;
	}

	this.render = function(){

		var map = this.level.plainMap;
		var actors = this.level.actors;

		for (var i = 0; i < map.length; i++) {
			this.drawNodeCell(map[i]);
		};

		for (var i = 0; i < actors.length; i++) {
			this.drawActor(actors[i]);
		};

		this.drawMenu();
		this.drawTimer();
	}


	this.drawNodeCell = function(nodeCell){
		
		var x = this.gridLeftOffset + nodeCell.x * (this.cellSize + this.padding);
		var y = nodeCell.y * (this.cellSize + this.padding);

		var key = nodeCell.type;

		//clear bg
		this.context.fillStyle = "white";
		this.context.fillRect(x, y, this.cellSize, this.cellSize);

		//base
		var image = document.images["0"]; //!!! TODO imageManager
		this.context.drawImage(image, x, y, this.cellSize, this.cellSize);

		var image = document.images[key]; //!!! TODO imageManager
		this.context.drawImage(image, x, y, this.cellSize, this.cellSize);

		if (nodeCell.selected) {
			this.context.fillStyle = "rgba(250, 0, 0, 0.3)";
			this.context.fillRect(x, y, this.cellSize, this.cellSize);
		}
		
		
	}

	this.drawActor = function(actor){
		var stepSize = this.cellSize / actor.maxStep;
		var offset = stepSize * (actor.maxStep - actor.currentStep);
		var offsetX = offset * actor.directionX;
		var offsetY = offset * actor.directionY;

		var x = this.gridLeftOffset + actor.x * (this.cellSize + this.padding) - offsetX;
		var y = actor.y * (this.cellSize + this.padding) - offsetY;

		this.context.drawImage(actor.image, x, y, this.cellSize, this.cellSize);
	}

	this.pixelToCell = function(x, y){
		x -= this.gridLeftOffset;

		var line = Math.floor(y / (this.cellSize + this.padding));
		var col  = Math.floor(x / (this.cellSize + this.padding));

		if (! this.level.outOfBounds(col, line)){
			return this.level.map[line][col];
		}

		return null;
	}

	this.pixelToMenuType = function(x, y){

		if (x > this.gridLeftOffset) {
			return null;
		} 

		var position = y - this.menuTopOffset;
		var index = Math.floor(position / (this.cellSize + this.menuPadding));

		if (index < this.menu.length){
			return this.menu[index];
		}

		return null;
	}
	


	this.drawMenu = function(){
		
		var key;
		var image;

		var x = this.menuLeftOffset;
		var y;

		for (var i = 0; i < this.menu.length; i++) {

			var type = this.menu[i];

			key = "sprite-" + type;
			image = document.images[key]; //!!! TODO imageManager

			y = this.menuTopOffset + (this.cellSize + this.menuPadding) * i ;

			this.context.fillStyle = (type == this.selectedMenu) ? "#999999" : "grey";
			this.context.fillRect(x, y, this.cellSize * 2, this.cellSize );
			
			this.context.drawImage(image, x, y, this.cellSize, this.cellSize);

			var count = (this.level.minions[type] == null)  ? 0 : this.level.minions[type].length;

			this.context.font = "15px Courier";
			this.context.textAlign = 'center';
			this.context.fillStyle = "white";
			this.context.textBaseline = 'middle';
			this.context.fillText(count, x + this.cellSize + (this.cellSize / 2), y + this.cellSize / 2);

		};

	}


	this.drawTimer = function(){
		var value = 1+ (this.level.timer % 10);

		this.context.fillStyle = "grey";
		this.context.fillRect(0, this.height - this.cellSize, this.cellSize * 2, this.cellSize );
		
		this.context.font = "30px Courier";
		this.context.textAlign = 'center';
		this.context.fillStyle = "white";
		this.context.textBaseline = 'bottom';
		this.context.fillText(value, this.cellSize, this.height);
	}

	this.drawMessage = function(message){

		//var message = this.messages[this.currentMessage];

		this.context.fillStyle = "black";
		this.context.fillRect(0, 0, this.width, this.height);
		
		this.context.font = "40px Courier";
		this.context.textAlign = 'center';
		this.context.fillStyle = "white";
		this.context.textBaseline = 'bottom';
		this.context.fillText(message,  this.width / 2, this.height / 2);


	}

}
