function MainController(){

	this.renderer;
	this.levelLoader;
	this.canvas;

	this.frameRate;
	this.oneSecond;

	this.modeGame;
	this.modeMessage;

	this.currentLevel = 1;
	this.maxLevel = 4;

	this.level;

	this.prepare = function(){
		this.modeGame = new ModeGameController(this);
		this.modeMessage = new ModeMessageController(this);

		this.modeGame.prepare();
		this.modeMessage.prepare();

		this.levelLoader.onLevelLoadedCallback = this.levelReady.bind(this);
	}

	this.run = function(){
		this.levelLoader.loadLevel(this.currentLevel);
		this.modeMessage.start("wait");
	}

	this.levelReady = function(level){
		this.level = level;
		this.renderer.level = level;
		this.level.renderer = this.renderer;
		this.modeMessage.start("ready");
	}

	this.messageValidated = function(currentMessage){

		console.log("Message clicked : " + currentMessage);

		switch(currentMessage){

			case "ready":
				this.modeMessage.stop();
				this.modeGame.start(this.level);
			break;
			case "succes":
				this.currentLevel ++;

				if (this.currentLevel > this.maxLevel){
					this.modeMessage.start("gameover");
					break;
				}

				this.run();
			break;
			case "fail":
				this.run();
			break;
			case "gameover":
				this.currentLevel = 1;
				this.run();
			break;
		}

	}

	this.levelFail = function(){
		console.log("LEVEL FAIL");
		this.modeGame.stop();
		this.modeMessage.start("fail");
	}

	this.levelSuccess = function(){
		console.log("LEVEL SUCCESS");
		this.modeGame.stop();
		this.modeMessage.start("succes");
	}

}


