
function ModeGameController(controller){

	this.controller = controller;
	
	this.level;

	this.selectedCell;
	this.selectedMinion;
	this.selectedMinionType = "blocker";

	this.pathfinder;

	this.selectionEventBind;
	this.frameEventTimer;
	this.timerEventTimer;

	this.chiefStartTime = 10;
	this.chiefTimeOut = 20;

	this.selectCell = function(cell){

		if (cell == null) {
			return false;
		}

		if (cell.type == 3) {
			return false;
		}

		if (this.selectedCell) {
	    	this.selectedCell.selected = false;
	    }

	    this.selectedCell = cell;
	    this.selectedCell.selected = true;

	    return true;
	}

	this.prepare = function(){
		this.pathfinder = new AStarFinder();		
	}

	this.start = function(level){
		this.level = level;

		console.log("Start GAME MODE");

		//chief moves...
		this.level.chief.updater = new ArbitraryExplorer();
		this.level.chief.updater.active = false;
		this.level.chief.updater.destination = level.endNodeCell;
		this.level.chief.updater.onDestinationReachListener = this.controller.levelSuccess.bind(this.controller);

		level.render();

		if (this.selectionEventBind == null) {
			console.log("Start GAME MODE : ADD EVENT");

			this.selectionEventBind = this.selectionEvent.bind(this);
			this.controller.renderer.canvas.addEventListener('click', this.selectionEventBind);
			this.controller.renderer.canvas.addEventListener('touch', this.selectionEventBind);
		
			this.frameEventTimer = window.setInterval(this.frameEvent.bind(this), this.frameRate);
			this.timerEventTimer = window.setInterval(this.timerEvent.bind(this), this.oneSecond);
		}
		
		

	}

	this.stop = function(){
		console.log("Stop GAME MODE");

		console.log("Start GAME MODE : RM EVENT");
		this.controller.renderer.canvas.removeEventListener('click', this.selectionEventBind);
		this.controller.renderer.canvas.removeEventListener('touch', this.selectionEventBind);
	
		window.clearInterval(this.frameEventTimer);
		window.clearInterval(this.timerEventTimer);

		this.selectionEventBind = null;
		this.frameEventTimer = null;
		this.timerEventTimer = null;

	}

	this.selectionEvent = function(event){
		
		//position in pixels
		var x = event.pageX - this.controller.renderer.canvas.offsetLeft;
	    var y = event.pageY - this.controller.renderer.canvas.offsetTop;

	    var cell = this.controller.renderer.pixelToCell(x, y);
	    var type = this.controller.renderer.pixelToMenuType(x, y);

	    if (cell) {
	    	
			var path = this.pathfinder.find(this.level, this.level.startNodeCell, cell);

		    if (path != null && this.selectCell(cell)) {

		    	if (this.level.minions[this.selectedMinionType].length > 0) {

		    		this.selectedMinion = this.level.minions[this.selectedMinionType][0];
			    	//remove from list...
			    	this.level.minions[this.selectedMinionType].splice(0,1);

				    this.selectedMinion.updater = new PathExplorer();
				    this.selectedMinion.updater.path = path;
		    		this.selectedMinion = null;
		    		
		    	}


		    }

	    }

	    this.level.render();
	}


	this.frameEvent = function(){
		console.log("Frame");

		this.level.render();  //order is important... to do : exception to change mode
		this.level.update();
	}	

	this.timerEvent = function(){
		console.log("Timer ");
		this.level.timer ++;

		if (this.level.timer == this.chiefStartTime) {
			this.level.chief.updater.active = true;
		} else if (this.level.timer == this.chiefTimeOut) {
			this.controller.levelFail();
		}
	}

}



